Type TBombe
	Const 	BOMBENFRAMES	:Int=3 'Anzahl der Frames der BombenGrafik
	Global 	BombenIMG		:TImage = LoadAnimImage("gfx/bombe.png",TS,TS,0,BOMBENFRAMES)

	Global BombenListe	:TList = CreateList() 'eine globale Liste fr alle Bomben anlegen
	
	Field Besitzer		:Int 'wer hat die Bombe gelegt ?
	Field xFeld		:Int 'Koordinaten der Bombe auf dem Feld
	Field yFeld		:Int
	
	Field FeuerKraft	:Int 'Reichweite der Explosionen einer Bombe
	
	Field BombenFrame		:Int = 0 'Aktuelles Frame der BombenGrafik (0=erstes Frame)
	Field BombenCountDown	:Int = 3 'jede Bombe soll nach 3 Sekunden (oder Intervallen) explodieren
	Field BombenIntervall	:Int = 1000 'der Intervall mit dem runtergezhlt wird (1000 = 1 Sekunde)
	Field BombenTimer		:Int = MilliSecs() 'aktuelle Zeit setzen
	
	Method Update()

		If MilliSecs() > BombenTimer+BombenIntervall
			BombenCountDown:-1 'Intervall erreicht, CountDown um 1 verringern
			BombenTimer=MilliSecs()
			If BombenFrame < BOMBENFRAMES-1
				BombenFrame:+1 'Frame um 1 erhhen, solange Anzahl an Frames der Grafik noch nicht erreicht
			End If
		End If
		
		If Map.Feld[xFeld,yFeld].Explosion = True 'Explosion auf Feld
			BombenCountDown = 0 'Bombe zur Explosion bringen
		End If
		
		If BombenCountDown <=0 'CountDown ist abgelaufen *BOOOM*
			Spieler[Besitzer].GelegteBomben:-1 'damit der Spieler wieder neue Bomben legen kann
			BombenListe.Remove(Self) 'Bombe aus Liste lschen
			Map.Feld[xFeld,yFeld].Inhalt = NIX 'wichtig! Inhalt des Feldes auf NIX zurck setzen
			TExplosion.Erstellen(xFeld,yFeld,FeuerKraft) 'Explosion wird erstellt
		End If
		
	End Method
	
	Method Zeichnen()
		DrawImage (BombenIMG,xFeld*TS,yFeld*TS,BombenFrame)
	End Method
	
	Function Erstellen:TBombe(Besitzer:Int,xFeld:Int,yFeld:Int,FeuerKraft:Int) 'neue Bombe wird erstellt
		Local NeueBombe:TBombe = New TBombe
		
		NeueBombe.Besitzer = Besitzer 'Wer hat die Bombe gelegt?
		NeueBombe.xFeld=xFeld 'Koordinaten der neuen Bombe bergeben
		NeueBombe.yFeld=yFeld
		
		NeueBombe.FeuerKraft=FeuerKraft
		
		Map.Feld[xFeld,yFeld].Inhalt = BOMBE 'wichtig! Inhalt des Feldes auf Bombe setzen
		BombenListe.AddLast(NeueBombe) 'neue Bombe der globalen BombenListe hinzufgen
	End Function
End Type