Type TExplosion
	Const 	EXPLOFRAMES	:Int=49 'Anzahl der Frames der ExplosionsGrafik
	Global 	ExplosionsIMG	:TImage = LoadAnimImage("gfx/explosion.png",TS,TS,0,EXPLOFRAMES)

	Global ExplosionsListe	:TList = CreateList() 'eine globale Liste fr alle Explosionen anlegen

	Field xFeld		:Int 'Koordinaten der Explosion auf dem Feld
	Field yFeld		:Int
	
	Field FeuerKraft		:Int 'Reichweite der Explosionen
	Field ExplosionsRichtung	:Int 'Richtung, in die Explosion sich "fortpflanzt"
	
	Const OBEN			:Int = 0 'nur wieder um nicht mit Zahlen
	Const UNTEN			:Int = 1 'hantieren zu mssen
	Const LINKS			:Int = 2
	Const RECHTS			:Int = 3
	Const ALLE			:Int = 5
		
	Field ExplosionsFrame	:Int = 0 'Aktuelles Frame der ExplosionsGrafik (0=erstes Frame)
	Field ExplosionsIntervall:Int = 5 'der Intervall mit dem die Frames gewechselt werden
	Field ExplosionsTimer	:Int = MilliSecs() 'aktuelle Zeit setzen
	
	Method Update()
		
		Map.Feld[xFeld,yFeld].Explosion = True 	'muss immer erneut gesetzt werden, da berschneidende
										'Explosionen den Status zu frh aufheben knnen
		
		If Map.Feld[xFeld,yFeld].Inhalt = SBLOCK 'wenn SoftBlock auf Feld
			FeuerKraft=0 'auf 0 setzen, Explosion soll sich nicht weiter fortpflanzen
			'ExplosionsFrame = EXPLOFRAMES-1 DIENT vorerst nur Testwecken ;)
			Map.Feld[xFeld,yFeld].Inhalt = NIX
		End If

		If MilliSecs() > ExplosionsTimer+ExplosionsIntervall
			ExplosionsTimer=MilliSecs()
			
			If Feuerkraft > 0
				FeuerKraft:-1 'um 1 reduzieren, damit korrekter Wert an nchste Explosion gegeben wird
				
				If ExplosionsRichtung = OBEN Or ExplosionsRichtung = ALLE
					If Map.Feld[xFeld,yFeld-1].Inhalt <> HBLOCK 'wenn in ExplosionsRichtung KEIN HardBlock
						TExplosion.Erstellen(xFeld,yFeld-1,FeuerKraft,OBEN) 'neue Explosion in Richtung
					End If
				End If
				If ExplosionsRichtung = UNTEN Or ExplosionsRichtung = ALLE
					If Map.Feld[xFeld,yFeld+1].Inhalt <> HBLOCK 'wenn in ExplosionsRichtung KEIN HardBlock
						TExplosion.Erstellen(xFeld,yFeld+1,FeuerKraft,UNTEN) 'neue Explosion in Richtung
					End If
				End If
				If ExplosionsRichtung = LINKS Or ExplosionsRichtung = ALLE
					If Map.Feld[xFeld-1,yFeld].Inhalt <> HBLOCK 'wenn in ExplosionsRichtung KEIN HardBlock
						TExplosion.Erstellen(xFeld-1,yFeld,FeuerKraft,LINKS) 'neue Explosion in Richtung
					End If
				End If
				If ExplosionsRichtung = RECHTS Or ExplosionsRichtung = ALLE
					If Map.Feld[xFeld+1,yFeld].Inhalt <> HBLOCK 'wenn in ExplosionsRichtung KEIN HardBlock
						TExplosion.Erstellen(xFeld+1,yFeld,FeuerKraft,RECHTS) 'neue Explosion in Richtung
					End If
				End If
				
				FeuerKraft=0 'auf 0 setzen, damit keine endlos Fortpflanzung entsteht
			End If
			
			If ExplosionsFrame < EXPLOFRAMES-1
				ExplosionsFrame:+1 'Frame um 1 erhhen, solange Anzahl an Frames der Grafik noch nicht erreicht
			Else 'wenn max Explosionsframes erreicht sind, Explosion lschen
				ExplosionsListe.Remove(Self) 'Explosion aus Liste lschen
				Map.Feld[xFeld,yFeld].Explosion = False 'Wichtig! Feld auf false setzen
			End If
		End If
		
	End Method

	
	Method Zeichnen()
		DrawImage (ExplosionsIMG,xFeld*TS,yFeld*TS,ExplosionsFrame)
	End Method
	
	Function Erstellen:TExplosion(xFeld:Int,yFeld:Int,FeuerKraft:Int,ExplosionsRichtung:Int=ALLE) 
		Local NeueExplosion:TExplosion = New TExplosion
		
		NeueExplosion.xFeld=xFeld 'Koordinaten der neuen Explosion bergeben
		NeueExplosion.yFeld=yFeld
		
		If Map.Feld[xFeld,yFeld].Inhalt = BOMBE 'wenn Bombe auf Feld
			FeuerKraft=0 'auf 0 setzen, Explosion soll sich nicht weiter fortpflanzen
		Else
			NeueExplosion.FeuerKraft=FeuerKraft 				'ansonsten Feuerkraft und
			NeueExplosion.ExplosionsRichtung=ExplosionsRichtung 	'Richtung in die sie sich "fortpflanzt" bergeben
		End If
		
		Map.Feld[xFeld,yFeld].Explosion = True 'wichtig! Inhalt des Feldes auf true setzen
		ExplosionsListe.AddLast(NeueExplosion) 'neue Bombe der globalen BombenListe hinzufgen
	End Function

End Type