Type TSpieler
	
	Field SpielerNr		:Int 'Welcher Spieler bin ich? 1,2,3 oder 4
	Field xFeld			:Int 'x und y Koordinaten fr das entsprechende FELD
	Field yFeld			:Int 'auf dem sich der Spieler befindet
	Field xPos			:Int 'x und y Koordinaten fr Pixelweise Bewegung
	Field yPos			:Int
	Field Speed			:Int = 2 'man bewegt sich immer um 2 Pixel pro Bewegung
	
	Field FeuerKraft		:Int = 2 'Reichweite der Explosionen einer Bombe (2 Felder in alle Richtungen)
	Field BombenMenge		:Int = 1 'Anzahl an Bomben, die der Spieler gleichzeitig legen kann
	Field MaxBombenMenge	:Int = 5 'egal wieviele Items man sammelt, man kann nie mehr legen, als hier verzeichnet
	Field GelegteBomben		:Int 'Wieviel hat der Spieler bereits gelegt und sind noch nicht explodiert?
	
	Const OBEN			:Int = 0
	Const UNTEN			:Int = 1
	Const LINKS			:Int = 2
	Const RECHTS			:Int = 3
	
	Field SpielerIMG		:TImage 'speichert die Grafik des Spielers
	Field BewegungsTimer	:Int = MilliSecs()
	Field BewegungsPause	:Int = 20
	
	Method Steuerung() 'Enthlt die Steuerungsabfrage
		If MilliSecs() > BewegungsTimer+BewegungsPause 'wenn Bewegung wieder erlaubt (Zeit)
			If 		KeyDown(KEY_UP) And MilliSecs() 'wenn Pfeiltaste OBEN gedrckt wird
				Bewegung(OBEN)
			ElseIf 	KeyDown(KEY_DOWN) And MilliSecs() 'wenn Pfeiltaste UNTEN gedrckt wird
				Bewegung(UNTEN)
			ElseIf 	KeyDown(KEY_LEFT) And MilliSecs() 'wenn Pfeiltaste LINKS gedrckt wird
				Bewegung(LINKS)
			ElseIf 	KeyDown(KEY_RIGHT) And MilliSecs() 'wenn Pfeiltaste RECHTS gedrckt wird
				Bewegung(RECHTS)
			End If
		End If
		If KeyHit(KEY_LCONTROL)		'wenn linke STRG Taste gedrckt wird
			BombeLegen() 			'dann Methode zum Bombenlegen aufrufen
		End If
	End Method
	
	Method BombeLegen()
		If Map.Feld[xFeld,yFeld].Inhalt = NIX 'wenn aktuelles Feld leer ist
			If GelegteBomben < BombenMenge And GelegteBomben < MaxBombenMenge
			'wenn bisher weniger Bomben gelegt als man kann UND als man darf
				TBombe.Erstellen(SpielerNr,xFeld,yFeld,FeuerKraft) 'Bombe erstellen
				GelegteBomben:+1 'um 1 erhhen, da ja nun eine bombe gelegt wurde
			End If
		End If
	End Method
	
	Method Bewegung(Richtung:Int)
		Local x		:Int 'Temporre Speicher
		Local y		:Int
		Local fx		:Int 'Temporre Speicher fr zu prfende Felder
		Local fy		:Int 'ist fy=-1 wird oberes vom aktuellen Feld geprft

		Local xMod	:Int = (xPos Mod TS) 'Temporrer Speicher fr den xPos modulus von TS (32)
		Local yMod	:Int = (yPos Mod TS)

		Select Richtung
			Case OBEN
				fy=-1	'oberes Feld prfen
			Case UNTEN
				fy=+1	'unteres Feld prfen
			Case LINKS
				fx=-1	'linkes Feld prfen
			Case RECHTS
				fx=+1	'rechtes Feld prfen
		End Select
		
		If Map.Feld[xFeld+fx,yFeld+fy].Inhalt = NIX 'wenn auf dem zu prfenden Feld NIX ist
		
			If fy <> 0 'ist das zu prfende Feld oben oder unten, dann auf Autobewegung checken
				If 		xFeld*TS < xPos	'ist (X Feldkoordinate*TS) kleiner als Pixelkoordinate
					x=-Speed 				'dann um Speed Pixel nach links bewegen
				Else If 	xFeld*TS > xPos 	'ist (X Feldkoordinate*TS) grer als Pixelkoordinate
					x=+Speed 				'dann um Speed Pixel nach rechts bewegen
				Else
					y=fy*Speed			'passt es genau, dann um Speed Pixel nach fy bewegen
				End If 
			End If
			
			If fx <> 0 'ist das zu prfende Feld links oder rechts, dann auf Autobewegung checken
				If 		yFeld*TS < yPos	'ist (Y Feldkoordinate*TS) kleiner als Pixelkoordinate
					y=-Speed				'dann um Speed Pixel nach oben bewegen
				Else If	yFeld*TS > yPos	'ist (Y Feldkoordinate*TS) grer als Pixelkoordinate
					y=+Speed				'dann um Speed Pixel nach unten bewegen
				Else
					x=fx*Speed			'passt es genau, dann um Speed Pixel nach fx bewegen
				End If
			End If
				
		Else If fy <> 0 And yMod <> 0 'wenn nicht begehbar aber noch nicht ganz auf dem Feld, dann trotzdem bewegen
			y=fy*Speed
		Else If fx <> 0 And xMod <> 0 'wenn nicht begehbar aber noch nicht ganz auf dem Feld, dann trotzdem bewegen
			x=fx*Speed
		End If
		
		yPos:+y 'Spieler Koordinaten aktualisieren
		xPos:+x
		
		MapFeld() 'Aktuelles Map.Feld[,] wird berechnet
		
		BewegungsTimer = MilliSecs()
		
	End Method
		
	Method MapFeld() 'berechnet aktuelles Map.Feld[,]
		Local xMod	:Int = (xPos Mod TS) 'Temporrer Speicher fr den xPos modulus von TS (32)
		Local yMod	:Int = (yPos Mod TS)

		If yMod < (TS/2) Then yFeld=(yPos/TS)		'wenn modulus < als 16
		If yMod > (TS/2) Then yFeld=(yPos/TS)+1		'wenn modulus > als 16
		If xMod < (TS/2) Then xFeld=(xPos/TS)		'wenn modulus < als 16
		If xMod > (TS/2) Then xFeld=(xPos/TS)+1		'wenn modulus > als 16
		
	End Method
	
	Method Update()
		If Map.Feld[xFeld,yFeld].Item = ITEM_AUFGEDECKT 'wenn aufgedecktes Item auf SpielerFeld
			For Local Item:TItem = EachIn TItem.ItemListe 'jedes erstellte Item durchgehen
				If xFeld=Item.xFeld And yFeld=Item.yFeld 'wenn richtiges Item gefunden
					Map.Feld[xFeld,yFeld].Item = 0 'ItemFlag auf 0
					Item.Sammler = SpielerNr 'Spieler der es gesammelt hat festlegen
				End If
			Next
		End If
	End Method
		
	Method Zeichnen()
		'DrawRect (xFeld*TS,yFeld*TS,TS,TS) 'Erstmal auskommentiert... vorerst klappt ja alles ;)
		DrawImage (SpielerIMG,xPos,yPos,0)
	End Method
	
	Function Erstellen:TSpieler (SpielerNr:Int,xFeld:Int,yFeld:Int,ImgPfadName:String,ImgFrames:Int)
		Local NeuerSpieler		:TSpieler = New TSpieler 'Temporren Spieler erstellen
		
		NeuerSpieler.SpielerNr	= SpielerNr 'welcher Spieler bin ich?
		NeuerSpieler.xFeld 		= xFeld 'Start FELD Koordinaten bergeben
		NeuerSpieler.yFeld 		= yFeld
		NeuerSpieler.xPos 		= xFeld*TS 'Koordinaten fr Pixelweise Bewegung fllen
		NeuerSpieler.yPos 		= yFeld*TS
		NeuerSpieler.SpielerIMG	= LoadAnimImage (ImgPfadName,TS,TS,0,ImgFrames)
		'AnimImage laden mit hhe und breite von 32 (da TS=32)
		
		Return NeuerSpieler 'Temporr erstellten Spieler zurck geben
	End Function

End Type
